﻿Imports System.Data.SqlClient
Imports System.IO

Public Class _Default
    Inherits System.Web.UI.Page

    Private ConnectionString As String = "Data Source=.\sqlexpress;Initial Catalog=Northwind;Integrated Security=True"
    Dim sql As String = "Select * from Customers"

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        If Not Page.IsPostBack Then
            Dim cn As SqlConnection = Nothing
            Dim ds As New DataSet
            Try
                cn = New SqlConnection(ConnectionString)
                cn.Open()
                Dim ad As New SqlDataAdapter(sql, cn)
                ad.Fill(ds)
                gdvDados.DataSource = ds.Tables(0)
                gdvDados.DataBind()
            Catch ex As Exception
                Throw ex
            Finally
                cn.Close()
            End Try
        End If
    End Sub

    Protected Sub btnExportar_Click(sender As Object, e As EventArgs) Handles btnExportar.Click

        Dim str As New StringBuilder()
        Dim cn As New SqlConnection(ConnectionString)
        Dim ds As New DataSet()

        Try
            cn.Open()
            Dim ad As New SqlDataAdapter(sql, cn)
            ad.Fill(ds)

            Dim i As Integer
            For i = 0 To ds.Tables(0).Rows.Count - 1
                Dim j As Integer
                For j = 0 To ds.Tables(0).Columns.Count - 1
                    str.Append(ds.Tables(0).Rows(i)(j).ToString())
                    str.Append(",")
                Next j

                str.Append("<br/>")
            Next i

            Response.Clear()
            Response.AddHeader("content-disposition", "attachment;filename=ArquivoExportado.txt")
            Response.Charset = ""
            Response.Cache.SetCacheability(HttpCacheability.NoCache)
            Response.ContentType = "application/vnd.text"

            Dim stringWrite As New StringWriter()
            Dim htmlWrite = New HtmlTextWriter(stringWrite)

            Response.Write(str.ToString())
            Response.End()

        Catch ex As Exception
            Throw ex
        Finally
            cn.Close()
            cn.Dispose()
        End Try

    End Sub
End Class